<!doctype html>	<!-- means HTML 5 -->

<!--


	To customize this file, scroll down to the last page or two, around line # 670.
	There you will find examples and instructions on setting your devices.

	Place this file and accompanying iamges in your web site folder and
	point your web browser to it.

	This page does depend on Javascript.

-->

<html>
<head>
	<title>My Devices</title>

	<style type = "text/css">

		.deviceListStyle
		{
			position: absolute;
			width: 320px;
			/* list height depends on device count. 480, more as needed */
			margin: 50px 10px 10px 10px;	/* add 50px above to clear the toolbar */
			padding: 5px;
			border: 1px solid;
			border-radius: 10px;
			-moz-border-radius: 10px;
		/*	background: rgba( 247, 251, 147, 0.30 );	f7fb93	*/			
			background: -webkit-gradient( linear, left top, left bottom, from(#EEEE7B), to(#E4D1AC));
			background: -moz-linear-gradient( top, #EEEE7B 0%, #E4D1AC 100% );
			text-align: center;
			list-style-type: none;
		}

		.deviceLineStyle
		{
			height: 70px;
			border-bottom: 1px solid #dddddd;
			border-left: 1px solid #aaaaaa;
			border-right: 1px solid #aaaaaa;
			padding: 5px 10px 0px 10px;
			background: #ffdddd;
			vertical-align: middle;
			font: 18px "Lucida Grande", Lucida, Verdana, sans-serif;
		}

		.leftImage
		{
			float: left;
			text-align: left;
			margin-top: 0px;
			margin-bottom: 0px;
			margin-right: 15px;
			padding: 0px;
		}

		.toolBar
		{
			position: absolute;
			left: 0px; top: 0px; z-index: -100;
			width: 100%; height: 40px;
			border: none;
			background: -webkit-gradient(
						linear,
						left top,
						left bottom,
						color-stop( 0.0, #ffffff ),
						color-stop( 0.025, #9facc2 ),
						color-stop( 0.49, #788AA8 ),
						color-stop( 0.5, #6D80A0 ),												color-stop( 0.975, #6D80A0 ),
						color-stop( 1.0, #000000 )
						);
			background: -moz-linear-gradient(
						center top,
						#ffffff 0%,
						#9facc2 2.5%,
						#788AA8 49%,
						#6D80A0 50%,
						#6D80A0 97.5%,
						#000000 100%
						);
			font-family: "Lucida Grande", Lucida, Verdana, sans-serif;
			color: white;
		}

	</style>

											 
	<script>

		var gSliderChangePending = false;
		var gNameOfPendingSlider = "";
		var gAmountOfPendingSlider = 50;
		var	gSliderChangeTimer = 0;
		var gSwitchLeftPosWhenOff = -55;

		var gDraggingSwitch = false;
		var gDraggedSwitchStartingMouseLeft = 0;
		var gTotalPixelsDragged = 0;	// Used for telling a plain click from a drag


		function abs( x )
		{
			x = parseInt( x );
			if ( x >= 0 )
				return x;
			else
				return -x;
		}

		function endsWith( str, suffix )
		{
			return str.match( suffix + "$" ) == suffix;
		}


		function operateDevice( deviceName, action, amount )
		{
			deviceName = encodeURI( deviceName );
			action = action.toLowerCase();

			requestActionURL = "http://localhost/cgi-bin/thinkingHome-cgi?devName=" + deviceName + "&action=" + action;
			if ( action != "turnon" &&
				 action != "turnoff" &&
				 amount != undefined )
				requestActionURL += "&amount=" + amount;

			// Have to set an iframe source
			fetcherDiv = document.getElementById( "hiddenURLFetcher" );
			fetcherDiv.src = requestActionURL;

			// now update the device's status text, image


			gSliderChangePending = false;
			gNameOfPendingSlider = "";
			gAmountOfPendingSlider = 50;
		}

		function sliderChanged( event )
		{
			deviceName = event.target.name;
			action = "dimTo";

			if ( gSliderChangePending && deviceName != gNameOfPendingSlider )
			{
				// handle the pending one before staging more
				operateDevice( gNameOfPendingSlider, action, gAmountOfPendingSlider );
			}

			gSliderChangePending = true;
			gNameOfPendingSlider = deviceName;
			gAmountOfPendingSlider = event.target.value;

			// clear any pending timer
			if ( gSliderChangeTimer != 0 )
			{
				clearTimeout( gSliderChangeTimer );
				gSliderChangeTimer = 0;
			}

			// set a new one
			gSliderChangeTimer = setTimeout( "followUpOnPendingSlider();", 1000 );
		}

		function sliderBlurred( event )
		{
			elt = document.getElementById( "errorMsgDiv" );
			elt.style.visibility = "visible";
			if ( sliderIsStale )
				elt.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;stale";
			else
				elt.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;fresh";

		}

		function followUpOnPendingSlider()
		{
			if ( !gSliderChangePending )
				return;

			operateDevice( gNameOfPendingSlider, action, gAmountOfPendingSlider );
			gSliderChangeTimer = 0;
		}


		function toggleImage( target )
		{
			// Now we should move the image left or right.
			width = target.parentNode.style.width;	// has "px" suffix, like "200px"
			width = parseInt( width.substring( 0, width.length - 2 ));	// now, just a num

			newLeft = 0;

			if ( target.value == 0 )
			{
				// turning "Off" by shifting back to the right.
				newLeft = 0;
				deltaX = 30;
				target.value = 1;
			}
			else
			{
				// turning "Off" by shifting to the left.

				newLeft = gSwitchLeftPosWhenOff;
				deltaX = -30;
				target.value = 0;
			}

			top = target.style.top;
			if ( top != "" )
			{
				top = top.substr( 0, top.length - 2 );	// remove "px" suffix
				top = parseInt( top );
			}
			else
				top = 0;

			animateElement( target.id, newLeft, top, deltaX, 0 );

			return false;	// we don't want the browser taking further action

		} // toggleImage



		function animateElement( eltID, destX, destY, deltaX, deltaY )
		{
			var elt = document.getElementById( eltID );

			var newX = elt.style.left;	// should have "px" suffix
			if ( endsWith( newX, "px" ) )
				newX = newX.substr( 0, newX.length - 2 );
			if ( newX == "" )
				newX = 0;
			else
				newX = parseInt( newX );
			newX += deltaX;
			if ( newX > destX && deltaX > 0 )
				newX = destX;
			else if ( newX < destX && deltaX < 0 )
				newX = destX;
			elt.style.left = newX + "px";

			var newY = elt.style.top;	// has "px" suffix
			if ( endsWith( newY, "px" ) )
				newY = newY.substr( 0, newY.length - 2 );
			if ( newY == "" )
				newY = 0;
			else
				newY = parseInt( newY );
			newY += deltaY;
			if ( newY > destY && deltaY > 0 )
				newY = destY;
			else if ( newY < destY && deltaY < 0 )
				newY = destY;
			elt.style.top = newY + "px";


			if ( newX != destX || newY != destY )
			{
				// Renew the timer
				var	animScript = "animateElement( \"" + eltID + "\", " + destX + ", " + destY + ", " + deltaX + ", " + deltaY + " );"
				animationTimer = setTimeout( animScript, 100 );
			}

		} // animateElement


		function handleSwitch( target )
		{
			// Get the image toggled left or right
			toggleImage( target );

			if ( target.value == 1 )
				action = "turnOn";
			else
				action = "turnOff";

			operateDevice( target.id, action, 0 );
		}

		// We use dragging to track the switch during the mouse down.
		// It works for a standard click, too.
		function switchDragStart( event )
		{
			gDraggingSwitch = true;
			gDraggedSwitchStartingMouseLeft = event.pageX;
			gTotalPixelsDragged = 0;
		}

		function switchDragContinue( event )
		{
			if ( !gDraggingSwitch )
				return;

			imageElt = event.target;
			deltaX = event.pageX - gDraggedSwitchStartingMouseLeft;
			
			// Note how much we're dragging (vs a plain click)
			gTotalPixelsDragged += abs( deltaX );

			if ( imageElt.value == 0 )
				startingImageLeft = gSwitchLeftPosWhenOff;
			else
				startingImageLeft = 0;
			newImageLeft = startingImageLeft + deltaX;
			if ( newImageLeft < gSwitchLeftPosWhenOff )
				newImageLeft = gSwitchLeftPosWhenOff;
			else if ( newImageLeft > 0 )
				newImageLeft = 0;

			imageElt.style.left = newImageLeft + "px";
		}

		function switchDragEnd( event )
		{
			gDraggingSwitch = false;
			imageElt = event.target;

			// Figure out if we should turn on or off and do it
			newLeft = imageElt.style.left;
			if ( endsWith( newLeft, "px" ) )
				newLeft = newLeft.substr( 0, newLeft.length - 2 );
			
			if ( newLeft > (gSwitchLeftPosWhenOff / 2) )
			{
				wantsOn = true;
				newLeft = 0;
				deltaX = 30;
			}
			else
			{
				wantsOn = false;
				newLeft = gSwitchLeftPosWhenOff;
				deltaX = -30
			}

			wasOn = parseInt( imageElt.value );

			// Handle a plain click.
			if ( gTotalPixelsDragged < 3 )
				wantsOn = !wasOn;

			if ( ( wantsOn && !wasOn) ||
				 (!wantsOn &&  wasOn) )
			{
				handleSwitch( imageElt );
			}
			else
			{
				// Put it back to where it started

				top = imageElt.style.top;
				if ( top != "" )
				{
					top = top.substr( 0, top.length - 2 );	// remove "px" suffix
					top = parseInt( top );
				}
				else
					top = 0;

				animateElement( imageElt.id, newLeft, top, deltaX, 0 );
			}
		}

	</script>

</head>
<body style = "background: url( images/iBackdrop.png ) repeat;">

	<!-- This hidden element is used for fetching URLs. -->
	<!--<div style = "visibility: visible;"> -->
	<div style = "visibility: hidden; position: absolute;">
		<iframe id = "hiddenURLFetcher" src = "">

		</iframe>
	</div>


	<div class = "toolBar">
		<table width = "100%"><tr>
			<td style = "width: 30px; padding: 10px"><img src = "images/th2-icon-small.png"></td>
			<td height = "32" align = "center" valign = "middle">
				Thinking Home
			</td>
			<td style = "width: 30px; padding: 10px">&nbsp;</td>
		</tr></table>
	</div>

	<?php

		$errorMessageHTML = "";	// may be set as device status is fetched

		$debugBorders = "";
		//$debugBorders = "border: 1px solid;"; // uncomment to see all borders

		$linesInList = 0;	// for alternating background colors


		// Returns true if the first string begins with the second string.
		// E.g. campground, camp
		function beginsWith( $str, $sub )
		{
			// yes, 3 = chars
			return ( substr( $str, 0, strlen( $sub ) ) === $sub );
		}


		// returns true if the first string contains the second string.
		// E.g. scamper, camp
		function contains( $str, $sub )
		{
			if ( strstr( $str, $sub ) == FALSE )
				return FALSE;
			else
				return TRUE;
		}


		// gets the device status string. E.g. "On", "On, dimmed", "Off", "32F"
		function getDeviceStatus( $deviceName )
		{
			// Handle any spaces or special chars in the device name.
			$deviceName = urlencode( $deviceName );

			$fetchStatusURL = "http://localhost/cgi-bin/thinkingHome-cgi?devName={$deviceName}&action=status";
			$sess = curl_init( $fetchStatusURL );
			curl_setopt( $sess, CURLOPT_RETURNTRANSFER, true );
			$devStatus = curl_exec( $sess );
			curl_close( $sess );

			//$devStatus = "<!doctype bogus>Some error occured (testing HTML.)";
			if ( $devStatus == "" )
			{
				$devStatus = "?";
			}
			else if ( beginsWith( $devStatus, "<!doctype" ) )
			{
				// Display the error in an error message div at the top.
				global $errorMessageHTML;
				$errorMessageHTML = $devStatus;

				$devStatus = "?";
			}

			return $devStatus;

		} // getDeviceStatus


		// scales the image to fit. Keeps the proportions of the original.
		function makeImageDiv( $imageURL, $maxWidth, $maxHeight )
		{
			$width = $maxWidth;
			$height = $maxHeight;
			if ( $imageURL != "" )
			{
				// If the file is not found, suppress the mess using the @ char.
				list( $width, $height, $type, $attr ) = @getimagesize( $imageURL );

				if ( $php_errormsg !== "" )
				{
					 error_log( $php_errormsg );
											 
					$width = $maxWidth;
					$height = $maxHeight;
				}
			}


			$scale = 1.00;

			if ( $width > $maxWidth )
				$scale = $maxWidth / $width;

			if ( $height > $maxHeight )
			{
				$scale = min( $scale, $maxHeight / $height );
			}

			$width = (int) ($width * $scale);
			$height = (int) ($height * $scale);

			global	$debugBorders;
			$imgDiv = "\n				<div class = \"leftImage\" style = \"width: {$width}px; height: {$height}px; opacity: 1.0;$debugBorders\">\n";
			if ( $imageURL != "" )
				$imgDiv .= "					<img width = \"$width\" height = \"$height\" src = \"$imageURL\" alt = \"DPic\" style = \"$debugBorders\">\n";
			$imgDiv .= "				</div>\n\n";

			return $imgDiv;

		} // makeImageDiv


		// Makes an HTML blob for the device name, status, pitcure, etc.
		function makeDeviceDiv( $deviceName, $deviceImageURL, $attributes )
		{
			$devStatus = getDeviceStatus( $deviceName );
			$cleanDeviceName = preg_replace( '/\s*/m', '', $deviceName );

			// $attributes may be "dimmable", "readonly" or empty

			global	$debugBorders;
			global	$linesInList;

			if ( $linesInList++ % 2 == 0 )
				$lineBGColor = "#ffffff";
			else
				$lineBGColor = "#ddeeff";


			$deviceDivHTML = "\n		<li>\n";
			$deviceDivHTML .= "			<div class = \"deviceLineStyle\" id = \"$cleanDeviceName\" style = \"background: $lineBGColor; $debugBorders\">\n";

			// Place the device image, if any
			$imageDiv = makeImageDiv( $deviceImageURL, 60, 60 );
			$deviceDivHTML .= $imageDiv;

			// set default elements
			$ledWanted = true;
			$statusTextWanted = false;
			$switchWanted = true;
			$dimmerWanted = false;

			// The control and status image or text are in this div, on the right.
			$deviceDivHTML .= "				<!-- Status and Control -->\n";
			$deviceDivHTML .= "				<div style = \"float: right; margin-top: 15px; vertical-align: middle; $debugBorders\">\n\n";



			// Now, the control. Switch or slider
			if ( contains( $attributes, "dimmable" ) )
			{
				// Show a slider
				$dimmerWanted = true;
				$switchWanted = false;
				$ledWanted = false;
			}
			else if ( contains( $attributes, "readonly" ) )
			{
				// No controls. Like a sensor.
				$switchWanted = false;
			}
			if ( contains( $attributes, "textStatus" ) )
			{
				// A read-only device may need text, like 65F.
				$statusTextWanted = true;
				$ledWanted = false;
				$switchWanted = false;
			}

			// Ensure we don't show a redundant LED
			if ( $switchWanted || $dimmerWanted )
				$ledWanted = false;

			if ( $ledWanted )
			{
				// Show the LED indicator for standard On, On dimmed and Off statuses
				$gotBasicStatus = false;
				if ( $devStatus == "On" )
				{
					$bulbImageURL = "images/greenBall.png";
					$gotBasicStatus = true;
				}
				else if ( beginsWith( $devStatus, "On, dimmed" ) )
				{
					$bulbImageURL = "images/yellowBall.png";
					$gotBasicStatus = true;
				}
				else
				{
					$bulbImageURL = "images/blackBall.png";
					$gotBasicStatus = true;
				}

				if ( $gotBasicStatus )
				{
					$deviceDivHTML .= "					<div style = \"float: left; width: 24px; $debugBorders\">\n";
					$deviceDivHTML .= "						<img src = \"$bulbImageURL\"  >\n";
					$deviceDivHTML .= "					</div>\n\n";
				}

			}	// end of LED section


			if ( $switchWanted )
			{
				// $switchValue on-off value for the toggle switch.
				$switchLeft = "0";
				if ( beginsWith( $devStatus, "On" ) )
				{
					$switchValue = 1;
				}
				else
				{
					$switchValue = 0;
					$switchLeft = "-55";
				}
				$deviceDivHTML .= "					<div id = \"toggleX\"\n";
				$deviceDivHTML .= "						style = \"width: 94px; height: 27px; border: 0.5px solid rgba(128, 128, 128, 0.1); border-radius: 5px; -moz-border-radius: 15px; overflow: hidden;\"\n";
				$deviceDivHTML .= "					>\n";

				$deviceDivHTML .= "						<div style = \"position: relative; width: 149px; height: 27px; border: 0.5px solid rgba(128, 128, 128, 0.1); border-radius: 5px; -moz-border-radius: 15px; overflow: hidden; left: 0px;\">\n";
				$deviceDivHTML .= "							<input type = \"image\"\n";
				$deviceDivHTML .= "									style = \"position: relative; left: {$switchLeft}px; border: 0.5px solid rgba(128, 128, 128, 0.1); border-radius: 5px; -moz-border-radius: 15px; overflow: hidden; opacity: 1.0;\"\n";
				$deviceDivHTML .= "									id = \"$deviceName\"\n";
				$deviceDivHTML .= "									src = \"images/onOffToggle.png\"\n";
				$deviceDivHTML .= "									value = \"$switchValue\"\n";
				$deviceDivHTML .= "									onMouseDown = \"switchDragStart( event );\"\n";
				$deviceDivHTML .= "									onMouseMove = \"switchDragContinue( event );\"\n";
				$deviceDivHTML .= "									onmouseUp = \"switchDragEnd( event );\">\n";
				$deviceDivHTML .= "						</div>\n";
				$deviceDivHTML .= "					</div>\n";


			}
			else if ( $dimmerWanted )
			{
				$initialValue = "50";
				if ( $devStatus == "On" )
					$initialValue = "100";

				else if ( $devStatus == "Off" )
					$initialValue = "0";

				else if ( contains( $devStatus, "dimmed" ) )
				{
					// maybe it is like "On, dimmed at 75%"
				}

				$deviceDivHTML .= "				<div style = \"float: right; $debugBorders\">\n";

				$deviceDivHTML .= "					<!-- Slider works nicely in Safari and iCab. Plain, unrestricted text field in Firefox.\n";
				$deviceDivHTML .= "						http://www.w3.org/TR/html5/number-state.html#range-state\n";
				$deviceDivHTML .= "					-->\n";
				$deviceDivHTML .= "					<input type = \"range\" min = 0 max = 100 step = 25 value = $initialValue\n";
				$deviceDivHTML .= "							id = \"$deviceName\"\n";
				$deviceDivHTML .= "							name = \"$deviceName\"\n";
				$deviceDivHTML .= "							width = 60\n";
				$deviceDivHTML .= "							onchange = \"sliderChanged( event );\"\n";
				$deviceDivHTML .= "							onblur = \"sliderBlurred( event );\" />\n";

				$deviceDivHTML .= "				</div>\n";
			}

			if ( $statusTextWanted )
			{
				// Typically for temp sensors

				$deviceDivHTML .= "					<div style = \"margin-left: 0px; text-align: center; $debugBorders\">\n";
				$deviceDivHTML .= "						$devStatus\n";
				$deviceDivHTML .= "					</div>\n";
			}

			$deviceDivHTML .= "				</div>\n\n";	// end of status ball and text div



			// Show the device name in the middle. Must be after the floating divs left and right
			$deviceDivHTML .= "\n\n";
			$deviceDivHTML .= "				<div style = \"height: 60px; display: table-row; $debugBorders\">\n";
			$deviceDivHTML .= "					<div style = \"display: table-cell; vertical-align: middle; opacity: 1.0;$debugBorders\">\n";
			$deviceDivHTML .= "						$deviceName\n";
			$deviceDivHTML .= "					</div>\n";
			$deviceDivHTML .= "				</div>\n";



			$deviceDivHTML .= "			</div>\n";	// end of device line div
			$deviceDivHTML .= "		</li>\n";

			return $deviceDivHTML;

		} // makeDeviceDiv






											 
											 
											 
											 




		/*
			Add your devices here.
			
			Attributes can be
				"dimmable"
				"readonly" (for motion and temp sensors)
				"textStatus"

			They can be combined, like "readOnly, textStatus"
		*/
		$devices[] = array( "name" => "Office Fan",
						   "pictureLocation" => "images/ceilingFan.png",
						   "attributes" => "" );

		 $devices[] = array( "name" => "Porch Lamp",
							"pictureLocation" => "images/Lamp.png",
							"attributes" => "" );
		 
		 $devices[] = array( "name" => "Library Lamp",
							"pictureLocation" => "images/stainedGlassLamp.png",
							"attributes" => "dimmable" );
		 
		 $devices[] = array( "name" => "Desk Fan",
							"pictureLocation" => "images/Fan.png",
							"attributes" => "" );
		 
											 
		
		





		$listHeight = "480";
		if ( count( $devices ) > 6 )
			$listHeight = 480 + 60 * ( count( $devices ) - 6);

		echo "	<!-- The device list begins here. -->\n";
		echo "<form onsubmit = \"return false;\">	<ul class = \"deviceListStyle\" style = \"height: {$listHeight}px;\">\n\n";

		foreach ( $devices as $device )
		{
			$deviceName =
			$deviceDiv = makeDeviceDiv( $device[ "name" ],
										$device[ "pictureLocation" ],
										$device[ "attributes" ] );
			echo $deviceDiv;
		}

		echo "	</ul></form>\n";


		if ( $errorMessageHTML == "" )
			$errorVisibleStr = "hidden";
		else
			$errorVisibleStr = "visible";

		$errorMsgDiv = "\n\n\n		<div id = \"errorMsgDiv\"\n		style = \"visibility: $errorVisibleStr; position: fixed; top: 0px; width: auto; height: 30px; border: 2px solid #000000; padding: 5px; background: rgba( 255, 255, 0, 0.70 ); text-align: center; color: red;\">\n";
		$errorMsgDiv .= "								{$errorMessageHTML}\n";
		$errorMsgDiv .= "		</div>\n\n";
		echo $errorMsgDiv;
	?>


</body>
</html>

