<!doctype html>	<!-- means HTML 5 -->

<html>
    <head>
        <title>My Floor Plan</title>

		<style type="text/css">
			.deviceDivStyle
			{
				position: absolute;
				width: 70px;
				height: 80px;
				margin: 10px;
				padding: 10px;
				border-radius: 15px;
				-moz-border-radius: 15px;
				background: rgba( 247, 251, 147, 0.90 );
				text-align: center;
			}

			.leftImage
			{
				float: left;
				text-align: left;
				margin-top: 0px;
				margin-bottom: 0px;
				padding: 0px;
			}

		</style>

		<script>

			function operateDevice( deviceName, action, amount )
			{
				deviceName = encodeURI( deviceName );
				action = action.toLowerCase();

				requestActionURL = "http://localhost/cgi-bin/thinkingHome-cgi?devName=" + deviceName + "&action=" + action;
				if ( action != "turnon" &&
					 action != "turnOff" &&
					 amount != undefined )
					requestActionURL += "&amount=" + amount;

				// Have to set an iframe source
				fetcherDiv = document.getElementById( "hiddenURLFetcher" );
				fetcherDiv.src = requestActionURL;
				
				// now update the device's status text, image
			}

			var sliderIsStale = false;

			function sliderChanged( event )
			{
				sliderIsStale = true;
				
				deviceName = "Office Lamp";
				action = "dimTo";
				
				amount = event.target.value;
				
				operateDevice( deviceName, action, amount )

			}

			function sliderBlurred( event )
			{
				elt = document.getElementById( "errorMsgDiv" );
				elt.style.visibility = "visible";
				if ( sliderIsStale )
					elt.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;stale";
				else
					elt.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;fresh";
				
			}

		</script>

    </head>
	<body style = "background: url( images/FloorPlan.png ) no-repeat;">

		<!-- This hidden element is used for fetching URLs. -->
<!--		<div style = "visibility: visible;"> -->
			<div style = "visibility: hidden; position: absolute;">	
			<iframe id = "hiddenURLFetcher" src = "">

			</iframe>
		</div>

		<?php
			
			$errorMessageHTML = "";	// may be set as device status is fetched

			$debugBorders = "";
			//$debugBorders = "border: 1px solid;"; // uncomment to see all borders

			// returns true if the first string begins with the second string.
			// E.g. camp, campground
			function beginsWith( $str, $sub )
			{
				// yes, 3 = chars
				return ( substr( $str, 0, strlen( $sub ) ) === $sub );
			}
			

			// gets the device status string. E.g. "On", "On, dimmed", "Off", "32F"
			function getDeviceStatus( $deviceName )
			{
				// Handle any spaces or special chars in the device name.
				$deviceName = urlencode( $deviceName );

				$fetchStatusURL = "http://localhost/cgi-bin/thinkingHome-cgi?devName={$deviceName}&action=status";
				$sess = curl_init( $fetchStatusURL );
				curl_setopt( $sess, CURLOPT_RETURNTRANSFER, true );
				$devStatus = curl_exec( $sess );
				curl_close( $sess );

				//$devStatus = "<!doctype bogus>Some error occured (testing HTML.)";
				if ( $devStatus == "" )
				{
					$devStatus = "?";
				}
				else if ( beginsWith( $devStatus, "<!doctype" ) )
				{
					// Display the error in an error message div at the top.
					global $errorMessageHTML;
					$errorMessageHTML = $devStatus;
					
					$devStatus = "?";
				}

				return $devStatus;

			} // getDeviceStatus
			
			
			// scales the image to fit. Keeps the proportions of the original.
			function makeImageDiv( $imageURL, $maxWidth, $maxHeight )
			{
				list( $width, $height, $type, $attr ) = getimagesize( $imageURL );
			
				$scale = 1.00;

				if ( $width > $maxWidth )
					$scale = $maxWidth / $width;

				if ( $height > $maxHeight )
				{
					$scale = min( $scale, $maxHeight / $height );
				}

				$width = (int) ($width * $scale);
				$height = (int) ($height * $scale);

				global	$debugBorders;
				$imgDiv = "\n		<div class = \"leftImage\" style = \"width: {$width}px; height: {$height}px; $debugBorders\">\n";
				$imgDiv .= "			<img width = \"$width\" height = \"$height\" src = \"$imageURL\" alt = \"Device Picture\" style = \"$debugBorders\">\n";
				$imgDiv .= "		</div>\n\n";

				return $imgDiv;

			} // makeImageDiv
			

			// Makes an HTML blob for the device name, status, pitcure, etc.
			function makeDeviceDiv( $deviceName, $pixelsAcross, $pixelsDown, $deviceImageURL )
			{
				$devStatus = getDeviceStatus( $deviceName );
				$cleanDeviceName = preg_replace( '/\s*/m', '', $deviceName );


				global	$debugBorders;
				$deviceDivHTML = "\n	<div class = \"deviceDivStyle\" id = \"$cleanDeviceName\" style = \"left: " . $pixelsAcross . "px; top: " . $pixelsDown . "px; $debugBorders\">\n";
			
				// Place the device image, if any
				if ( $deviceImageURL != "" )
				{
					$imageDiv = makeImageDiv( $deviceImageURL, 60, 60 );
					$deviceDivHTML .= $imageDiv;
				}
				
				// The status image and text are in this div, on the right.
				$deviceDivHTML .= "		<div style = \"float: right; margin-top: 15px; vertical-align: middle;\">\n";
				
				
				// Show the LED indicator for standard On, On dimmed and Off statuses
				$gotBasicStatus = false;
				if ( $devStatus == "On" )
				{
					$bulbImageURL = "images/greenBall.png";
					$gotBasicStatus = true;
				}
				else if ( beginsWith( $devStatus, "On, dimmed" ) )
				{
					$bulbImageURL = "images/yellowBall.png";
					$gotBasicStatus = true;
				}
				else
				{
					$bulbImageURL = "images/blackBall.png";
					$gotBasicStatus = true;
				}

				if ( $gotBasicStatus )
				{
					$deviceDivHTML .= "			<div style = \"float: right; $debugBorders\">\n";
					$deviceDivHTML .= "				<img src = \"$bulbImageURL\"  >\n";
					$deviceDivHTML .= "			</div>\n\n";
				}

				
				// Show the text of the device status
				$deviceDivHTML .= "			<div style = \"margin-left: 0px; text-align: center; $debugBorders\">\n";
				$deviceDivHTML .= "				$devStatus\n";
				$deviceDivHTML .= "			</div>\n";
								
				$deviceDivHTML .= "		</div>\n\n";	// end of status div

				// Show the device name.
				// This is tricky since it could be very wide and we still want it centered.
				$deviceDivHTML .= "		<br>\n\n";
				$deviceDivHTML .= "		<div style = \"position: absolute; bottom: 0px; left: -50%; width: 200%; text-align: center; $debugBorders\">\n";
				$deviceDivHTML .= "			<div style = \"text-align: center; $debugBorders\">\n				<div style = \"width: 100%; $debugBorders\">\n";
				$deviceDivHTML .= "					$deviceName\n";
				$deviceDivHTML .= "				</div>\n";
				$deviceDivHTML .= "			</div>\n";
				$deviceDivHTML .= "		</div>\n";

				
				$deviceDivHTML .= "	</div>\n\n";

				return $deviceDivHTML;
				
			} // makeDeviceDiv
	

			
			// $deviceDiv = makeDeviceDiv( "Device Name", Left, Top, ImagePath );
			$deviceDiv1 = makeDeviceDiv( "Office Fan", 230, 40, "images/Fan.png" );
			$deviceDiv2 = makeDeviceDiv( "Desk Lamp", 450, 200, "images/Lamp.png" );


			if ( $errorMessageHTML == "" )
				$errorVisibleStr = "hidden";
			else
				$errorVisibleStr = "visible";

			$errorMsgDiv = "<div id = \"errorMsgDiv\" style = \"visibility: $errorVisibleStr; position: fixed; top: 0px; width: auto; height: 30px; border: 2px solid #000000; padding: 5px; background: rgba( 255, 255, 0, 0.70 ); text-align: center; color: red;\">\n";
			$errorMsgDiv .= "								{$errorMessageHTML}\n";
			$errorMsgDiv .= "		</div>\n\n";
			echo $errorMsgDiv;


			echo $deviceDiv1;
			echo $deviceDiv2;


		?>



<!-- Works nicely in Safari. Plain, unrestricted text field in Firefox.
http://www.w3.org/TR/html5/number-state.html#range-state
-->
<input type="range" min=0 max=100 step=20 value=50
	onchange = "sliderChanged( event );"
	onblur = "sliderBlurred( event );" />
<input value = "hey" />


    </body>
</html>

